eval '(exit $?0)' && eval 'PERL=`which perl5`; exec $PERL -wS $0 ${1+"$@"}'
    & eval 'setenv PERL `which perl5`; exec $PERL -wS $0 $argv:q'
    if 0;

### Local Variables: ***
### mode:perl ***
### comment-column:0 ***
### comment-start: "### " ***
### comment-end: "***" ***
### End: ***
#
# ****************DO NOT MOVE OR CHANGE LINES ABOVE THIS*********************
#
# The first set of lines runs perl from any shell. The second set of lines 
# identifies the rest of the file as PERL for EMACS autoformatting. 
# See end of copyright for more information.
#
# ----------------------------------------------------------------------------
#                                   X-BONE
#
#                          http://www.isi.edu/xbone
#                USC Information Sciences Institute (USC/ISI)
#                   Marina del Rey, California 90292, USA
#                          Copyright (c) 1998-2004
# ----------------------------------------------------------------------------
#
# Copyright (c) 1998-2004 by the University of Southern California.
# All rights reserved.
#
# Permission to use, copy, modify, and distribute this software and its
# documentation in source and binary forms for non-commercial purposes and
# without fee is hereby granted, provided that the above copyright notice
# appear in all copies and that both the copyright notice and this permission
# notice appear in supporting documentation, and that any documentation,
# advertising materials, and other materials related to such distribution and
# use acknowledge that the software was developed by the University of
# Southern California, Information Sciences Institute.  The name of the
# University may not be used to endorse or promote products derived from this
# software without specific prior written permission.
#
# THE UNIVERSITY OF SOUTHERN CALIFORNIA MAKES NO REPRESENTATIONS ABOUT THE
# SUITABILITY OF THIS SOFTWARE FOR ANY PURPOSE.  THIS SOFTWARE IS PROVIDED "AS
# IS" AND WITHOUT ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, WITHOUT
# LIMITATION, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
# PARTICULAR PURPOSE.
#
# Other copyrights might apply to parts of this software and are so noted when
# applicable.
#
# ----------------------------------------------------------------------------
#
# Effort sponsored by the Defense Advanced Research Projects Agency
# (DARPA) and Air Force Research Laboratory, Air Force Materiel
# Command, USAF, under agreement numbers F30602-98-1-0200 and
# F30602-01-2-0529, and by National Science Foundation under agreement
# number ANI-0230789. The U.S. Government is authorized to reproduce
# and distribute reprints for Governmental purposes not withstanding
# any copyright annotation therein.  The views and conclusions
# contained herein are those of the authors and should not be
# interpreted as necessarily representing the official policies or
# endorsements, either expressed or implied, of the Defense Advanced
# Research Projects Agency (DARPA), the Air Force Research Laboratory,
# or the U.S. Government.
#
# ----------------------------------------------------------------------------
#  $RCSfile: xbonectl.pl,v $
#
# $Revision: 1.4 $
#   $Author: pingali $
#     $Date: 2004/04/21 02:26:15 $
#    $State: Exp $
# ----------------------------------------------------------------------------

# The first lines start PERL on any system where perl is in the path.
# This is a modified version of the "start perl" script provided in
# the PERL man pages, which starts perl on the remainder of the file
# regardless of whether it is run under sh, csh, or perl.
#
# This version is modified to dynamically locate the perl path, rather
# than requiring it be hard-coded.

use IO::Handle;

$_ = shift @ARGV; 
$_ = "" if (not defined $_);

SWITCH: {

  /start/ && do {
    my @cmd = ("xb-node-daemon", "-bg", @ARGV); 
    my $status = 0xff & system(@cmd); 
    die ("Could not start the xbone-daemon") if ($status);
    last SWITCH; 
  }; 

  /stop/ && do { 
    if (-e "/var/run/xbone.pid"){
      open(PID, "/var/run/xbone.pid");
      chomp($cpid=<PID>);
      print "Killing $cpid\n";
      kill 15, $cpid;
      close(PID);
    };
    last SWITCH; 
  };

  print "Usage: xbonectl.pl [start|stop]\n";

}

1; 
